import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:share_apps/utils/common_utils.dart';
import 'package:share_apps/utils/string_utils.dart';
import 'package:share_apps/widgets/widgets_importer.dart';

class InvitationComplete extends StatefulWidget {
  @override
  _InvitationCompleteState createState() => _InvitationCompleteState();
}

class _InvitationCompleteState extends State<InvitationComplete> {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: false,
      color: Colors.white,
      home: Scaffold(
        body: Container(
          color: Colors.white,
          child: Column(
            children: [
              Expanded(
                flex: 1,
                child: Align(
                  alignment: Alignment.bottomCenter,
                  child: Image.asset(
                    StringUtils.IC_LOGO,
                    width: 50,
                    height: 50,
                  ),
                ),
              ),
              AddSizeBox(100, 0),
              Expanded(
                flex: 3,
                child: Column(
                  children: <Widget>[
                    AddText(StringUtils.THANK_YOU, Colors.black, 22,
                        FontWeight.bold, false),
                    AddSizeBox(70, 0),
                    Text(
                      StringUtils.INVITATION_COMPLETE,
                      textAlign: TextAlign.center,
                      style: TextStyle(
                          decoration: TextDecoration.none,
                          fontSize: 22,
                          fontWeight: FontWeight.normal,
                          fontStyle: FontStyle.italic,
                          color: Colors.black),
                    ),
                    AddSizeBox(30, 0),
                    InkWell(
                      onTap: () {
                        CommonUtils.openURL(
                            StringUtils.LEARN_MORE_URL);
                      },
                      child: AddText(StringUtils.LEARN_MORE, Colors.black, 16,
                          FontWeight.normal, true),
                    ),
                    Expanded(
                      child: Center(
                        child: InkWell(
                          onTap: () {
                            Navigator.pop(context);
                          },
                          child: Text(
                            StringUtils.EXIT,
                            textAlign: TextAlign.center,
                            style: TextStyle(
                                decoration: TextDecoration.none,
                                fontSize: 18,
                                fontWeight: FontWeight.normal,
                                fontStyle: FontStyle.italic,
                                color: Colors.red),
                          ),
                        ),
                      ),
                    ),
                  ],
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
