import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:share_apps/model/user_bean.dart';
import 'package:share_apps/screens/contact_selection.dart';
import 'package:share_apps/utils/common_utils.dart';
import 'package:share_apps/utils/string_utils.dart';
import 'package:share_apps/widgets/widgets_importer.dart';

import 'invitaion_complete_screen.dart';

int _transfeID;
int _transactionId;
int numOfContactPerApi;
List<CustomContact> contactList, contactListForApiCall = new List();

class InviteContact extends StatefulWidget {
  UserBean bean;
  double percentage = 0;

  InviteContact(List<CustomContact> uiCustomContacts, UserBean bean) {
    contactList = uiCustomContacts;
    this.bean = bean;
  }

  @override
  _InviteContactState createState() => _InviteContactState();
}

class _InviteContactState extends State<InviteContact> {
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    _transactionId = 1;
    numOfContactPerApi = 50;
    BeginTransfer();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: false,
      color: Colors.white,
      home: Scaffold(
        body: Container(
          color: Colors.white,
          child: Column(
            children: [
              Expanded(
                flex: 1,
                child: Align(
                  alignment: Alignment.bottomCenter,
                  child: InkWell(
                    onTap: () async {},
                    child: Image.asset(
                      StringUtils.IC_LOGO,
                      width: 50,
                      height: 50,
                    ),
                  ),
                ),
              ),
              AddSizeBox(100, 0),
              Expanded(
                flex: 1,
                child: Container(
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: <Widget>[
                      Text(
                        StringUtils.INVITE_CONTACT_MESSAGE,
                        textAlign: TextAlign.center,
                        style: TextStyle(
                            decoration: TextDecoration.none,
                            fontSize: 15,
                            fontWeight: FontWeight.normal,
                            fontStyle: FontStyle.italic,
                            color: Colors.black),
                      ),
                      AddSizeBox(20, 0),
                      Text(
                        widget.percentage.toInt().toString() + " %",
                        textAlign: TextAlign.center,
                        style: TextStyle(
                            decoration: TextDecoration.none,
                            fontSize: 15,
                            fontWeight: FontWeight.normal,
                            fontStyle: FontStyle.italic,
                            color: Colors.black),
                      )
                    ],
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }

  Future<void> BeginTransfer() async {
    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
    });
    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.BEGIN_TRANSFER, body, context);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      _transfeID = map[StringUtils.TRANSFER_ID];
      InviteContact();
    }
  }

  Future<void> InviteContact() async {
    if (!(contactList.length > numOfContactPerApi)) {
      setState(() {
        widget.percentage = 30;
      });
    }
    contactListForApiCall = contactList
        .getRange(
            numOfContactPerApi * (_transactionId - 1),
            contactList.length > (numOfContactPerApi * _transactionId)
                ? (numOfContactPerApi * _transactionId)
                : contactList.length)
        .toList();

    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
      StringUtils.TRANSFER_ID: _transfeID,
      StringUtils.TRANSACTION_ID: _transactionId,
      StringUtils.CONTACTS: [
        for (int i = 0; i < contactListForApiCall.length; i++)
          getContact(i).toJson(),
      ],
    });

    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.INVITE_CONTACT, body, context);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      EndTransfer();
    }
  }

  Future<void> EndTransfer() async {
    if (!(contactList.length > numOfContactPerApi)) {
      setState(() {
        widget.percentage = 60;
      });
    }
    var body = json.encode({
      StringUtils.TOKEN: StringUtils.getToken(),
    });
    Map<String, dynamic> map =
        await CommonUtils.apiCall(StringUtils.END_TRANSFER, body, context);
    if (map[StringUtils.STATUS].toString().compareTo(StringUtils.SUCCESS) !=
        null) {
      if (_transactionId + 1 <=
          (contactList.length / numOfContactPerApi).ceil()) {
        setState(() {
          widget.percentage = ((100 * (_transactionId * numOfContactPerApi)) /
              contactList.length);
        });
        _transactionId = _transactionId + 1;
        BeginTransfer();
      } else {
        // CommonUtils.showToast(map[StringUtils.MESSAGE], Colors.green);
        Route route =
            MaterialPageRoute(builder: (context) => InvitationComplete());
        Navigator.pushReplacement(context, route);
      }
    }
  }

  ContactData getContact(int i) {
    String number = contactList[i].contact.phones.toList()[0].value.toString();
    return ContactData(
        contactList[i].contact.displayName,
        contactList[i].contact.emails.toList().length > 0
            ? contactList[i].contact.emails.toList()[0].value.toString()
            : '',
        number);
  }
}

class ContactData {
  String name = '', email = '', phone = '';

  ContactData(this.name, this.email, this.phone);

  Map toJson() => {
        'name': name,
        'email': email,
        'phone': phone,
      };
}
